[19.10 FEAT] zKVM: Add hardware CPU Model - qemu part

Bug #1830238 reported by bugproxy on 2019-05-23
18
This bug affects 1 person
Affects Status Importance Assigned to Milestone
Ubuntu on IBM z Systems
High
Canonical Server Team
qemu (Ubuntu)
Undecided
Skipper Bug Screeners

Bug Description

Support of additional hardware instructions in support of additional hardware instructions.

Will be made available with qemu 4.1

bugproxy (bugproxy) on 2019-05-23
tags: added: architecture-s39064 bugnameltc-177822 severity-high targetmilestone-inin1910
Changed in ubuntu:
assignee: nobody → Skipper Bug Screeners (skipper-screen-team)
affects: ubuntu → qemu (Ubuntu)
Frank Heimes (fheimes) wrote :

Set to incomplete for now, until version got released ...

no longer affects: qemu
Changed in ubuntu-z-systems:
status: New → Incomplete
importance: Undecided → High
assignee: nobody → Canonical Server Team (canonical-server)
Frank Heimes (fheimes) on 2019-05-23
tags: added: qemu-19.10

Qemu 4.1 is a stretch for Ubuntu 19.10.
While qemu 4.1 itself would release "just in time" the usual rule of thumb is that one should have a libvirt that is released later (to handle any new quirks). Now that is then already way into feature freeze - therefore while 4.1 is an option it is rather unlikely.

Is there any chance that the patch set can be isolated and applied on top of 4.0?
If so a list of commits that are needed would be great.

Ping on my question?

Changed in qemu (Ubuntu):
status: New → Incomplete

Yes, the feature can easily be backported to 4.0:

(optional) b1b9e0dc78a8 update-linux-headers: handle new header file
d9cb4336159a linux headers: update against Linux 5.2-rc1
eaf6f642abf1 s390x/cpumodel: ignore csske for expansion <--- this might already be in via LP1830704
2ec038836fa0 s390x/cpumodel: Miscellaneous-Instruction-Extensions Facility 3
5dacbe23d23c s390x/cpumodel: msa9 facility
54d65de0b525 s390x/cpumodel: vector enhancements
d220fabf1609 s390x/cpumodel: enhanced sort facility
afc7b8666b62 s390x/cpumodel: add Deflate-conversion facility
caef62430fed s390x/cpumodel: add gen15 defintions
c657e84faee4 s390x/cpumodel: wire up 8561 and 8562 as gen15 machines

Yep eaf6f642abf1 already is part of it via LP1830704

Thanks for the list, I'll give it a shot in the context of the work on qemu 4.0 for Eoan.

Changed in qemu (Ubuntu):
status: Incomplete → In Progress
Frank Heimes (fheimes) on 2019-06-25
information type: Private → Public
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2019-06-24 11:26 EDT-------

Frank Heimes (fheimes) on 2019-06-25
Changed in ubuntu-z-systems:
status: Incomplete → In Progress
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2019-06-25 03:26 EDT-------
You might want to add this build fix for mips that is required after the header sync,

commit 86e636951ddce2bb3a82fcaad5abc3779ba4f7ab
Author: Laurent Vivier <email address hidden>
AuthorDate: Thu May 23 19:54:13 2019 +0200
Commit: Aleksandar Markovic <email address hidden>
CommitDate: Sun May 26 17:44:33 2019 +0200

linux-user: fix __NR_semtimedop undeclared error

Also needs 8cf108c5 linux-headers: add linux/mman.h.
  Update it to 4.20-rc1
To have them matching as-is, the rest applies fine.

I don't have a machine with all those facilities - can this already be tested when I have a preliminary build or do we rely on "if applied as upstream things should be fine"?

bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2019-06-25 05:07 EDT-------
We can test a preliminary build.

In the PPA [1] is a preliminary build of a qemu 4.0 for Ubuntu 19.10.
This is still being tested, but a confirmation that this brings all the z14 related changes that you expect would be great - so I wanted to ask to test the PPA in regard to this bug here "zKVM: Add hardware CPU Model - qemu part ".

[1]: https://launchpad.net/~paelzer/+archive/ubuntu/qemu-4.0-eoan-v2

bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2019-07-01 06:36 EDT-------
It looks like the qemu contains all the necessary backports, but I could only test that partially as for a full test I need the related kernel change (ibm bug 177472 launchpad bug 1830239)

bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2019-07-01 07:11 EDT-------
With 5.2.0-050200rc7-generic from the kernel-mainline ppa this looks good.

Launchpad Janitor (janitor) wrote :
Download full text (7.0 KiB)

This bug was fixed in the package qemu - 1:4.0+dfsg-0ubuntu1

---------------
qemu (1:4.0+dfsg-0ubuntu1) eoan; urgency=medium

  * Merge with Upstream release of qemu 4.0.
    Among many other things this fixes LP Bugs:
    LP: #1782206 - SnowRidge Accelerator Interfacing Architecture (AIA)
    LP: #1828038 - Update s390x CPU Model for more HW support
    LP: #1832622 - count cache flush Spectre v2 mitigation for ppc64el
    Remaining Changes:
    - qemu-kvm to systemd unit
      - d/qemu-kvm-init: script for QEMU KVM preparation modules, ksm,
        hugepages and architecture specifics
      - d/qemu-system-common.qemu-kvm.service: systemd unit to call
        qemu-kvm-init
      - d/qemu-system-common.install: install helper script
      - d/qemu-system-common.maintscript: clean old sysv and upstart scripts
      - d/qemu-system-common.qemu-kvm.default: defaults for
        /etc/default/qemu-kvm
      - d/rules: call dh_installinit and dh_installsystemd for qemu-kvm
    - Enable nesting by default
      - d/qemu-system-x86.modprobe: set nested=1 module option on intel.
        (is default on amd)
      - d/qemu-system-x86.postinst: re-load kvm_intel.ko if it was loaded
        without nested=1
      - d/p/ubuntu/expose-vmx_qemu64cpu.patch: expose nested kvm by default
        in qemu64 cpu type.
      - d/p/ubuntu/enable-svm-by-default.patch: Enable nested svm by default
        in qemu64 on amd
      - d/qemu-system-x86.README.Debian: document intention of nested being
        default is comfort, not full support
    - Distribution specific machine type (LP: 1304107 1621042)
      - d/p/ubuntu/define-ubuntu-machine-types.patch: define distro machine
        types
      - d/qemu-system-x86.NEWS Info on fixed machine type defintions
        for host-phys-bits=true (LP: 1776189)
      - add an info about -hpb machine type in debian/qemu-system-x86.NEWS
      - provide pseries-bionic-2.11-sxxm type as convenience with all
        meltdown/spectre workarounds enabled by default. (LP: 1761372).
    - improved dependencies
      - Make qemu-system-common depend on qemu-block-extra
      - Make qemu-utils depend on qemu-block-extra
      - let qemu-utils recommend sharutils
    - s390x support
      - Create qemu-system-s390x package
      - Enable numa support for s390x
    - arch aware kvm wrappers
    - d/control: update VCS links
    - qemu-guest-agent: freeze-hook fixes (LP: 1484990)
      - d/qemu-guest-agent.install: provide /etc/qemu/fsfreeze-hook
      - d/qemu-guest-agent.dirs: provide /etc/qemu/fsfreeze-hook.d
    - d/control-in: enable RDMA support in qemu (LP: 1692476)
        - enable RDMA config option
        - add libibumad-dev build-dep
    - tolerate ipxe size change on migrations to >=18.04 (LP: 1713490)
      - d/p/ubuntu/pre-bionic-256k-ipxe-efi-roms.patch: old machine types
        reference 256k path
      - d/control-in: depend on ipxe-qemu-256k-compat-efi-roms to be able to
        handle incoming migrations from former releases.
    - d/control-in: Disable capstone disassembler library support (universe)
    - Move s390x roms to a new qemu-system-data-s390x
      - d/qemu-system-data.install: install s390x roms as archi...

Read more...

Changed in qemu (Ubuntu):
status: In Progress → Fix Released
Frank Heimes (fheimes) on 2019-07-03
Changed in ubuntu-z-systems:
status: In Progress → Fix Released
bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2019-07-03 11:13 EDT-------
IBM Bugzilla status -> closed, Fix Released with Eoan

bugproxy (bugproxy) wrote :

------- Comment From <email address hidden> 2019-07-09 10:20 EDT-------
There was an upstream fixup:

commit d05be57ddc2e1722f527aa4c20d84dfd15c840ec
s390: cpumodel: fix description for the new vector facility

would be good to add this as well.

Thanks, FYI this further fixup will be covered in https://bugs.launchpad.net/ubuntu/+source/qemu/+bug/1836066

To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers